/*
 * Per POSIX guidelines, this module reserves the CQ and cq prefixes
 * These are the cq_area.flags 
 */
#define CQ_EXIST 0x0001
#define CQ_BUSY	 0x0002
#define CQ_OFF	 0x0004
#define CQ_ABORT 0x0008


/* IOCTL numbers */

#define CQABORT     0x0714 
#define CQSETTEMPO  0x0716  /* Store whole note int cq_area. */
#define CQSETPITCH  0x0719  /* Store a timer divisor into cq_area. */
#define CQRESET     0x071c  /* reset speaker */
#define CQGETFLAGS  0x071e  /* get status flags */

#define CQ_BUFFER_SIZE  16
#define CQ_DEF_CHAR     0	/* Default character */
#define CQ_DEF_PITCH	440	/* Default pitch in Hz   */
#define CQ_DEF_TEMPO	160	/* Default temp in beats per minute */ 

struct cq_struct 
{
	int flags;
	unsigned int timerdiv;	/* Timer divisor  determines pitch */
	unsigned int wholenote; /* Duration in centiseconds (jiffies) */ 
	char buffer[CQ_BUFFER_SIZE];
	unsigned int buffer_offset;
	unsigned int buffer_end;
	char * mcode;
	struct wait_queue *cq_wait_q;
};

#define CQ_SYSP		0x61  	/* System port for controlling speaker */
#define CQ_DIVREG	0x42	/* Port for timer divisor */

/*
 * function prototypes
 */

extern int cq_init(void);
