#define SCALEX_EXIST	 0x0001
#define SCALEX_BUSY	 	0x0004
#define SCALEX_RPEND	 0x0008
#define SCALEX_RFULL	 0x0010
#define SCALEX_ERR  	 0x0020


#define SCALEX_COM_BASE 0x3f8
#define SCALEX_IIR_DATA_IN_FULL 4
#define SCALEX_IIR_DATA_OUT_EMPTY 2
#define SCALEX_LSR_DATA_IN_FULL 1
#define SCALEX_LSR_DATA_OUT_EMPTY 64
#define SCALEX_WRITE_SIZE 20
#define SCALEX_WRITE_BUFFER_SIZE 256
#define SCALEX_READ_BUFFER_SIZE 256 
#define SCALEX_READ_STRING_TERMINAL 10 


/* IOCTL numbers */
#define SCALEXRESET     0x072c  /* reset scalex*/
#define SCALEXGETFLAGS  0x072e  /* get status flags */


struct scalex_struct {
	unsigned long flags;
	unsigned int readin;
	unsigned int readout;
	unsigned int writein;
	unsigned int writeout;
	char *read_buffer;
	char *write_buffer;
	struct wait_queue *rdwait_q;
	struct wait_queue *wrwait_q;
};

extern int scalex_init(void);

