global scalex_interrupt
RBS equ 256 ;		This must be a power of 2.
COM1 equ 3F8H		; COM1 I/O base address and Data Port
extern scalex_area
extern __wake_up
extern printk
;
scalex_interrupt:
	PUSH ECX
	PUSH EDX
	PUSH EBX
	PUSH ESI
	PUSH EDI
;
	MOV EDX, COM1 + 5	; Line Status Register
	IN AL, DX			; Line Status Register
	TEST AL, 1			; See if Data Has Arrived
	JZ NEAR WRD			; No? Then Need to Write Data?
;
;	Process Incoming Data
;
	MOV ESI, [scalex_area + 4]	; readin component of structure
	ADD ESI, RBS + 2	;  Read Buffer Size + 2
	SUB ESI, [scalex_area + 8]	; readout component of structure
	AND ESI, RBS - 2	;  Read Buffer Size - 2
	JZ NEAR RBF			; Read Buffer Full
;
; These line tests whether tests whether the condition
; readin + 1 = readout OR readin + 2 = readout  (mod 2^n)
; is true.  If so the buffer has overflowed.  Note RBS = 2^n.
;
	MOV EDX, COM1		; Status port has zero offset
	IN AL, DX			; This is the data byte right here.
	MOV CL, AL			; Keep whole byte in AL
	AND ECX, 15			; Look at halves in CL
;
	MOV DL, [OKC + ECX]	; Translate incoming half byte 
	MOV ESI, [scalex_area + 4]	; readin component of structure
	MOV EBX, [scalex_area + 20]	; Get address of Read Buffer
	MOV [EBX + ESI], DL	; Store translated byte in Read Buffer
	INC ESI				; Increment readin
	AND ESI, RBS -1		; mod 2^n of course
	MOV [scalex_area + 4], ESI	;
	CMP DL, 10			; Was that a terminal signal?
	JZ NEAR RQW			; If so wake up the reading process.
;
	MOV CL, AL			; Now do the other half byte 
	SHR CL, 4
	MOV DL, [OKC + ECX]	; Translate incoming half byte 
	MOV [EBX + ESI], DL	; Store translated byte in Read Buffer
	INC ESI				; Increment readin
	AND ESI, RBS -1		; mod 2^n of course
	MOV [scalex_area + 4], ESI ;
	CMP DL, 10			; Was that a terminal signal?
	JZ RQW				; Read Queue Wakeup 
	JMP LEV	
;
; Process Outgoing Data
;
WRD:
	MOV EDX, COM1 + 2	; Interrupt Identification Register
	IN AL, DX			; 
	TEST AL, 2			; Check the Data Has Been Sent Bit
	JZ NEAR LEV
;
	MOV EDI, [scalex_area + 16]	; writeout component of scalex_area
	CMP EDI, [scalex_area + 12]	; writein component of structure
	JZ WQW				; Write Queue Wakeup
POL:
	MOV EDX, COM1 + 5	; Line Status Register 
	IN AL, DX			; 
	TEST AL, 64			; Data Has Been Sent Bit
	JZ POL				; Should be just a short wait 
	MOV EBX, [scalex_area + 24]	; Get address of Write buffer 
	MOV AL, [EDI + EBX]	; EDI still holds writeout  
	MOV EDX, COM1		; Data Port 
	OUT DX, AL			; Here is the outgoing byte!
	INC EDI				; Increment writeout
	MOV [scalex_area + 16], EDI	; and store it

	JMP LEV
;	
WQW:
;	PUSH dword scalex_area + 32
;	CALL waitqueue_active
;	ADD ESP, 4
	MOV EDX, 1;	TASK_INTERRUPTIBLE	
	MOV EAX, scalex_area + 32; Wake up
	CALL __wake_up
	JMP LEV
;
RQW:
	TEST dword [scalex_area], 8; test flags Component for Read Pending Bit 
	JZ LEV
	MOV EDX, 1 ; TASK_INTERRUPTIBLE
	MOV EAX, scalex_area + 28	;
	CALL __wake_up
	JMP LEV
RBF:
	PUSH dword OVR			; Overflow
	CALL printk
	ADD ESP, 4
	JMP LEV
;
OVR: db "Read buffer overflow!",0AH,0
OKC: db "0123456789AB-",0AH,".F"
;
LEV:
	POP EDI
	POP ESI
	POP EBX
	POP EDX
	POP ECX
	RET
